/*
 *
 * Copyright (c) 1998 Scott Oaks. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and
 * without fee is hereby granted.
 *
 * This sample source code is provided for example only,
 * on an unsupported, as-is basis. 
 *
 * AUTHOR MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. AUTHOR SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  AUTHOR
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 */


import java.security.*;
import java.io.*;

public class NewEmployee {
	public static void main(String args[]) {
		try {
			IdentityScope is = IdentityScope.getSystemScope();
			Signer origSigner = (Signer) is.getIdentity(args[0]);

			System.out.println("Please insert the floppy for " + args[0]);
			System.out.print("Press enter when ready:  ");
			System.in.read();
			XYZFileScope privateScope =
						new XYZFileScope("/floppy/floppy0/private");
			XYZSigner newSigner = new XYZSigner(args[0], privateScope);
			KeyPair kp = new KeyPair(origSigner.getPublicKey(),
									 origSigner.getPrivateKey());
			newSigner.setKeyPair(kp);
			newSigner.setInfo(origSigner.getInfo());
			Certificate certs[] = origSigner.certificates();
			for (int i = 0; i < certs.length; i++)
				newSigner.addCertificate(certs[i]);
			newSigner.setTrust(Integer.parseInt(args[1]));
			privateScope.save();

			XYZFileScope sharedScope =
						new XYZFileScope("/auto/shared/sharedScope");
			XYZIdentity newId = new XYZIdentity(args[0], sharedScope);
			newId.setPublicKey(origSigner.getPublicKey());
			newId.setInfo(origSigner.getInfo());
			certs = origSigner.certificates();
			for (int i = 0; i < certs.length; i++)
				newId.addCertificate(certs[i]);
			newId.setTrust(Integer.parseInt(args[1]));
			sharedScope.save();
		} catch (Exception e) {
			System.out.println(e);
		}
	}
}
