/*
 *
 * Copyright (c) 1998 Scott Oaks. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and
 * without fee is hereby granted.
 *
 * This sample source code is provided for example only,
 * on an unsupported, as-is basis. 
 *
 * AUTHOR MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. AUTHOR SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 *
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  AUTHOR
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 */


public class LoadClass extends ClassLoader {
protected Class loadClass(String name, boolean resolve) {
	Class c;
	SecurityManager sm = System.getSecurityManager();

	// Step 1 -- Check for a previously loaded class
	c = findLoadedClass(name);
	if (c != null)
		return c;
		
	// Step 2 -- Check to make sure that we can access this class
	if (sm != null) {
		int i = name.lastIndexOf('.');
		if (i >= 0)
			sm.checkPackageAccess(name.substring(0, i));
	}

	// Step 3 -- Check for system class first
	try {
	    c = findSystemClass(name);
	    return c;
	} catch (ClassNotFoundException cnfe) {
	    // Not a system class, simply continue
	}

	// Step 4 -- Check to make sure that we can define this class
	if (sm != null) {
		int i = name.lastIndexOf('.');
		if (i >= 0)
			sm.checkPackageDefinition(name.substring(0, i));
	}

	// Step 5 -- Read in the class file
	byte data[] = lookupData(name);

	// Step 4 and 5 -- Define the class from the data; this also
	//		 passes the data through the byte code verifier
	c = defineClass(name, data, 0, data.length);

	// Step 6 -- Resolve the internal references of the class
	if (resolve)
		resolveClass(c);

	return c;
}
	byte [] lookupData(String n) {
	    return new byte[1];
	}
}
